mplate_decoder/urls.py
from django.urls import path

from . import views

app_name = 'mplate_decoder'
urlpatterns = [
     path('decode/', views.MplateCreate.as_view(),
          name='mplate_create'),
     path('<slug:chassis_number_short>', views.MplateRetrieve.as_view(),
          name='mplate_retrieve'),
     path('<slug:chassis_number_short>/update/', views.MplateUpdate.as_view(),
          name='mplate_update'),
     path('<slug:chassis_number_short>/delete/', views.MplateDelete.as_view(),
          name='mplate_delete'),
     path('', views.MplateIndex.as_view(),
          name='mplate_index'),
     path('about/', views.MplateAbout.as_view(),
          name='mplate_about'),
     path('search/', views.SearchResultsView.as_view(),
          name='search_results'),
]

vw_type2_id/urls.py
from django.contrib import admin
from django.urls import include, path
from django.views.generic import TemplateView

urlpatterns = [
    path('', TemplateView.as_view(template_name='home.html'), name='home'),
    path('admin/', admin.site.urls),
    path('mplate/', include('mplate_decoder.urls')),
]

mplate_decoder/forms.py
from django.forms import ModelForm, ValidationError  # , TextInput
import re
from django.utils.text import slugify
from .models import (
    Mplate, Type2Model, Engine, Gearbox, MplateDecoder,
)

import logging
logger = logging.getLogger('django')


class MplateCreateForm(ModelForm):

    class Meta:
        model = Mplate
        fields = (
            'chassis_number_short',
            'm_codes_1',
            'm_codes_2',
            'paint_and_interior',
            'production_date',
            'production_planned',
            'export_destination',
            'model',
            'aggregate_code',
            'emden',
        )
        # widgets = {
        #    'chassis_number_short': TextInput(
        # attrs={'placeholder': 'CCCCCCCC'}),
        # }

    def clean_chassis_number_short(self):
        MODEL_6869_YEAR_CHASSIS_NR_LEN = 7
        MODEL_7079_YEAR_CHASSIS_NR_LEN = 8
        data = self.cleaned_data['chassis_number_short']
        decoder = MplateDecoder()

        if len(data) < MODEL_6869_YEAR_CHASSIS_NR_LEN:
            raise ValidationError(
                "Minimum digits: "
                "{} (mod. 68-68) or {} digits (mod. 70-79)".format(
                    MODEL_6869_YEAR_CHASSIS_NR_LEN,
                    MODEL_7079_YEAR_CHASSIS_NR_LEN
                ))

        # year_and_serial_from_chassis_no(str(data))
        if not re.match("^[0-9]+$", data):
            raise ValidationError(
                "Only digits allowed (no spaces either)")

        try:
            model_year = decoder.get_model_year(data)
        except ValidationError:
            raise ValidationError(
                "Invalid shortened chassis number. "
                "Check first and second digits."
            )

        logger.info(
            "Model year validation: {} ({})".format(
                model_year, type(model_year)))

        if model_year.year not in range(1968, 1980):
            raise ValidationError(
                "Invalid shortened chassis number. "
                "Check first and second digits."
            )

        data = slugify(data)

        qs = Mplate.objects.filter(chassis_number_short=data)

        # Update view
        if self.instance.pk:
            qs = qs.exclude(pk=self.instance.pk)

        if qs.exists():
            url = 'https://vw-type2-id.xyz/mplate/' + data
            href = '<a href="{}">{}</a>'.format(url, data)
            raise ValidationError(
                'M-Plate {} already exists.'.format(href))

        return data

    def clean_emden(self):
        data = self.cleaned_data['emden']

        data = data.upper()

        if data and (data != 'E'):
            raise ValidationError("Only the letter 'E' is allowed")

        return data

    def clean_m_codes(self, data):
        MCODE_LEN = 3
        mcodes_list = []

        if data:
            data = data.upper()
            if not re.match("^[A-Z0-9 ]+$", data):
                raise ValidationError(
                    "Only digits, letters and spaces allowed")

            if len(data) >= MCODE_LEN:
                if ' ' in data:
                    mcodes_list = data.split(' ')
                else:
                    mcodes_list = [data[i:i+MCODE_LEN]
                                   for i in range(0, len(data), MCODE_LEN)]

                for mcode in mcodes_list:
                    if len(mcode) != MCODE_LEN:
                        raise ValidationError(
                            "Code: {}. M-code length should be "
                            "{} digits or letters".format(mcode, MCODE_LEN)
                        )
                data = ' '.join(mcodes_list)
            else:
                raise ValidationError(
                            "Minimum M-code length: "
                            "{} digits or letters".format(MCODE_LEN)
                        )

        return data

    def clean_m_codes_1(self):
        data = self.clean_m_codes(self.cleaned_data['m_codes_1'])

        return data

    def clean_m_codes_2(self):
        data = self.clean_m_codes(self.cleaned_data['m_codes_2'])

        return data

    def clean_paint_and_interior(self):
        PAINT_AND_INTERIOR_LEN = 6
        data = self.cleaned_data['paint_and_interior']

        data = data.upper()

        if not re.match("^[A-Z0-9]+$", data):
            raise ValidationError("Only digits and letters allowed")

        if len(data) < PAINT_AND_INTERIOR_LEN:
            raise ValidationError(
                "Minimum paint and interior code length: "
                "{} digits or letters".format(
                    PAINT_AND_INTERIOR_LEN)
            )

        return data

    def clean_production_date(self):
        PRODUCTION_DATE_LEN = 3
        data = self.cleaned_data['production_date']

        data = data.upper()
        if not re.match("^[0-9]{2}[0-9OND]$", data):
            raise ValidationError("Only digits and letters allowed")

        if len(data) < PRODUCTION_DATE_LEN:
            raise ValidationError(
                "Minimum production date code length: "
                " {} digits or letters".format(
                    PRODUCTION_DATE_LEN)
            )

        return data

    def clean_production_planned(self):
        data = self.cleaned_data['production_planned']

        return data

    def clean_export_destination(self):
        EXPORT_DESTINATION_LEN = 2
        data = self.cleaned_data['export_destination']

        if data:
            data = data.upper()
            if not re.match("^[A-Z0-9]+$", data):
                raise ValidationError("Only digits and letters allowed")

            if len(data) < EXPORT_DESTINATION_LEN:
                raise ValidationError(
                    "Minimum destination country length:"
                    " {} letters or digits".format(
                        EXPORT_DESTINATION_LEN)
                )

        return data

    def clean_model(self):
        MODEL_LEN = 4
        data = self.cleaned_data['model']

        if len(data) < MODEL_LEN:
            raise ValidationError(
                "Minimum model code length: {} digits".format(
                    MODEL_LEN)
            )

        VALID_MODELS = Type2Model.objects.values_list('model', flat=True)
        VALID_MODELS = list(map(int, VALID_MODELS))

        logger.info('Valid models: {}'.format(VALID_MODELS))

        try:
            model_int = int(data[:2])
        except ValueError:
            raise ValidationError("Only digits allowed in model code")

        logger.info('Model code: {}'.format(model_int))

        if model_int not in VALID_MODELS:
            raise ValidationError("Invalid model code")

        return data

    def clean_aggregate_code(self):
        AGGREGATE_CODE_LEN = 2
        data = self.cleaned_data['aggregate_code']

        if len(data) < AGGREGATE_CODE_LEN:
            raise ValidationError(
                "Minimum aggregate code length: {} digits".format(
                    AGGREGATE_CODE_LEN)
            )

        valid_aggregates = []

        try:
            aggregate_int = int(data)
        except ValueError:
            raise ValidationError("Only digits allowed in aggregate code")

        for engine in Engine.objects.all():
            for gearbox in Gearbox.objects.all():
                if gearbox.gearbox_description.startswith('Automatic'):
                    if engine.engine_type == 'Type 4':
                        valid_aggregates.append(
                            (engine.engine_code * 10) + gearbox.gearbox_code)
                else:
                    valid_aggregates.append(
                        (engine.engine_code * 10) + gearbox.gearbox_code)

        if aggregate_int not in valid_aggregates:
            raise ValidationError("Invalid aggregate code")

        return data


class MplateUpdateForm(MplateCreateForm):

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

mplate_decoder/views.py
from django.views import generic
from django.http import JsonResponse, HttpResponse
from .models import (
    Mplate,
    MplateDecoder,
    Mcode,
    McodeCollection,
)
from .forms import MplateCreateForm, MplateUpdateForm
from django.urls import reverse_lazy
from django.db.models import Q
import logging

logger = logging.getLogger('django')


class AjaxableResponseMixin:
    """
    Mixin to add AJAX support to a form.
    Must be used with an object-based FormView (e.g. CreateView)
    """
    def form_invalid(self, form):
        response = super().form_invalid(form)
        if self.request.is_ajax():
            logger.info("form_invalid: ajax request")
            data = form.errors.as_json()
            response = HttpResponse(
                data,
                status=400,
                content_type='application/json')
        else:
            logger.info("form_invalid: NOT ajax request")

        # logger.info("form invalid, response: {}".format(response.content))
        return response

    def form_valid(self, form):
        # This method is called when valid form data has been POSTed.
        # It should return an HttpResponse.
        #
        # We make sure to call the parent's form_valid() method because
        # it might do some processing (in the case of CreateView, it will
        # call form.save() for example).
        response = super().form_valid(form)
        if self.request.is_ajax():
            logger.info("form_valid: ajax request")
            data = {
                'chassis_number_short': self.object.chassis_number_short,
            }
            response = JsonResponse(data)
        else:
            logger.info("form_valid: NOT ajax request")

        return response


class MplateIndex(generic.ListView):
    model = Mplate
    template_name = 'mplate_decoder/index.html'


class MplateAbout(generic.TemplateView):
    template_name = 'mplate_decoder/mplate_about.html'


class MplateCreate(AjaxableResponseMixin, generic.edit.CreateView):
    form_class = MplateCreateForm
    template_name = 'mplate_decoder/mplate_form.html'


class MplateRetrieve(generic.DetailView):
    model = Mplate
    template_name = 'mplate_decoder/detail.html'
    slug_field = 'chassis_number_short'
    slug_url_kwarg = 'chassis_number_short'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        mplate = super().get_object()
        decoder = MplateDecoder(mplate)

        context['plate'] = mplate.render_plate()
        context['chassis_number'] = mplate.get_chassis_number()
        context['model_year'] = decoder.get_model_year().year
        context['production_date'] = mplate.get_production_date()
        context['export_destination'] = mplate.get_export_destination()
        context['model_description'] = mplate.get_model()
        context['interiorcolor_description'] = mplate.get_interiorcolor()
        context['exteriorcolor_description'] = \
            mplate.get_exteriorcolor_description()
        context['engine_description'] = mplate.get_engine()
        context['gearbox_description'] = mplate.get_gearbox()
        context['m_codes'] = decoder.get_mcodes()
        context['emden'] = mplate.emden

        return context


class MplateUpdate(AjaxableResponseMixin, generic.edit.UpdateView):
    model = Mplate
    # fields = '__all__'
    form_class = MplateUpdateForm
    template_name = 'mplate_decoder/mplate_form.html'
    slug_field = 'chassis_number_short'
    slug_url_kwarg = 'chassis_number_short'


class MplateDelete(generic.edit.DeleteView):
    model = Mplate
    slug_field = 'chassis_number_short'
    slug_url_kwarg = 'chassis_number_short'
    success_url = reverse_lazy('mplate_decoder:mplate_index')


class SearchResultsView(generic.ListView):
    model = Mplate
    template_name = 'mplate_decoder/search_results.html'
    paginate_by = 25

    def get_queryset(self):

        results = None
        query = self.request.GET.get('q')

        if query:
            if query != '*':
                results = Mplate.objects.filter(
                    Q(m_codes_1__icontains=query)
                    | Q(m_codes_2__icontains=query)
                )
            else:
                results = Mplate.objects.all()

        return results

    def get_context_data(self, **kwargs):
        query = self.request.GET.get('q')
        context = super().get_context_data(**kwargs)

        m_code_query_set = Mcode.objects.filter(
                m_code__iexact=query)

        if not m_code_query_set:
            m_code_query_set = McodeCollection.objects.filter(
                m_code__iexact=query)

        context['m_code_query_set'] = m_code_query_set

        return context

mplate_decoder/templates/mplate_decoder/detail.html
{% extends "mplate_base_bootstrap.html" %}

{% load static %}
{% load svg %}

{% block content %}

<div class="row mt-4">

{{ plate|safe }}

</div>

<div class="row mt-4">

<h2>Specifications</h2>
<div class="table-responsive">
<table class="table table-hover">
  <tr>
    <td><strong>{{ 'Model'|upper }}</strong></td> 
    <td>{{ model_description|linebreaksbr }} </td>
  </tr>
  <tr>
    <td><strong>{{ 'Model year'|upper }}</strong></td> 
    <td>{{ model_year }}</td>
  </tr>
  <tr>
    <td><strong>{{ 'Engine'|upper }}</strong></td> 
    <td>{{ engine_description }} </td>
  </tr>
  <tr>
    <td><strong>{{ 'Transmission'|upper }}</strong></td> 
    <td>{{ gearbox_description }} </td>
  </tr>
  <tr>
    <td><strong>{{ 'Vehicle Ident. Nr.'|upper }}</strong></td> 
    <td>{{ chassis_number }}</td>
  </tr>
  <tr>
    <td><strong>{{ 'Production date'|upper }}</strong></td> 
    <td id="production-date">
        {{ production_date }}{% if emden %}. Manufactured at the Emden plant
            <ion-icon
              class="icon"
              data-toggle="tooltip"
              title="From December 1967 to April 1973, as the Hannover plant was over capacity"
              name="information-circle-outline">
            </ion-icon>
        {% endif %}
    </td>
  </tr>
  <tr>
    <td><strong>{{ 'Optional extras'|upper }}</strong></td> 
    <!-- <td>{{ mplate.m_codes_1 }} {{ mplate.m_codes_2 }}</td> -->
    <td>
    {% for key, value in m_codes.items %}
        {{ key }}: {{ value }} <br>
    {% endfor %}
    </td>
  <tr>
    <td><strong>{{ 'Exterior'|upper }}</strong></td> 
    <td>{{ exteriorcolor_description|linebreaksbr }} </td>
  </tr>  
  <tr>
    <td><strong>{{ 'Interior'|upper }}</strong></td> 
    <td>{{ interiorcolor_description }} </td>
  </tr>  
  <tr>
    <td><strong>{{ 'Destination country'|upper }}</strong></td> 
    <td>{{ export_destination }} </td>
  </tr>
</table>
</div>

</div>

{% endblock %}

{% block javascript %}
<script type="text/javascript" src="{% static 'js/bootstrap-tooltips.js' %}"></script>
{% endblock %}

mplate_decoder/templates/mplate_decoder/index.html
{% extends "mplate_base_bootstrap.html" %}
{% load svg %}

{% block content %}

<!-- Intro row -->
<div class="row mt-4">
  <div class="col">
    <p class="lead">
      The M-plate is one of the identification plates found on VW busses. 
      Short for <em>Mehraustattung</em> (optional extras in German), it contains
      production codes with information about equipment, manufacturing date, destination, specs and more.
    </p>
  </div>
</div>

<!-- Location rows -->
<div class="row mt-4">
  <div class="col-sm">
    <h2>Find it</h2>
  </div>
</div>

<div class="row mt-4">
  <div class="col-sm">
    <h4>
      <span class="text-muted">Model years 68-76</span>
    </h4>
    <img class="img-fluid img-thumbnail" src="https://www.thesamba.com/vw/gallery/pix/1039800.jpg">
    <p><small class="text-muted">Image from <a href="https://www.thesamba.com/vw/forum/viewtopic.php?p=7551789">The Samba forum</a></small></p>
    <p class="mt-1">
      <strong>Before model year 1977</strong>: the M-plate is located on the metal partition behind the driver's seat (passenger's seat for RHD vehicles).
    </p>
  </div>

  <div class="col-sm">
    <h4>
      <span class="text-muted">Model years 77-79</span>
    </h4>
    <img class="img-fluid img-thumbnail" src="https://www.thesamba.com/vw/gallery/pix/433251.jpg">
      <p><small class="text-muted">Image from <a href="https://www.thesamba.com/vw/forum/viewtopic.php?p=7551789">The Samba forum</a></small></p>
      <p class="mt-1">
        <strong>Model year 1977 and after</strong>: the M-plate is located under the dashboard, on top of the metal fresh air pipe. 
      </p>
  </div>
</div>

<!-- Decoder rows -->
<div class="row mt-4">
  <div class="col-sm">
    <h2>Decode it</h2>
  </div>
</div>

<div class="row mt-4">
  <div class="col-sm">
  <h4 class="mb-3">M-plate decoder</h4>
  <div>
    {% svg 'mplate-7079-form' %}
  </div>
  <p class="mt-3">
    Use the automatic decoder to find out more about the original configuration, equipment and extras for a Type 2 bus. Simply choose the model year and fill in the M-plate fields.
  </p>
  
  <div>
    <a class="btn btn-primary btn-lg btn-block mt-3 mb-4" href="{% url 'mplate_decoder:mplate_create' %}" role="button">Decode an M-plate&raquo;</a>
  </div>
</div>

<div class="col-sm">
    <h4 class="d-flex justify-content-between align-items-center mb-3">
      <span class="text-muted">M-plate submissions</span>
      <span class="badge badge-secondary badge-pill">{{ object_list.count }}</span>
    </h4>
    <ul class="list-group">
        {% for mplate in object_list|dictsortreversed:"id"|slice:":7" %}
            <li class="list-group-item d-flex justify-content-between align-items-center">
              <a href="{{ mplate.get_absolute_url }}">{{ mplate.chassis_number_short }}</a>
              <span class="badge badge-info badge-pill">New</span>
            </li>
        {% endfor %}
    </ul>
</div>

</div>

<div class="row mt-4">

</div>

{% endblock %}

mplate_decoder/templates/mplate_decoder/mplate_about.html
{% extends "mplate_base_bootstrap.html" %}
{% load markdownify %}
{% load i18n %}

{% block content %}

<div class="row mt-4">
<div class="col">

{% blocktrans asvar about_copy %}
## About this site

This site provides means to identify and understand the origin of Volkswagen Type 2 busses
from years 1967 to 1979. At this time, via an online M-Plate decoder, but it might expand in the future.
M-Plates were metallic plates present in all VW busses, which contained a set of alphanumeric production
codes to identify a vehicle.

The site was created as a result of the [original VW M-Plate decoder](https://web.archive.org/web/20181005162116/http://www.vw-mplate.com/mcode.php)
going offline, as a personal project to decode the author's own M-Plate and to experiment with code. From there,
it evolved into a public website to share this tool with other vintage bus owners from the aircooled community. 

The data used to decode the M-plates comes mainly from these sources, and keeps getting expanded every time a user finds out more about
an unknown code and shares it with the community:

- [VW Transporter and Microbus, Specification Guide 1967-1979](https://www.crowood.com/details.asp?isbn=9781847974808) - by Vincent Molenaar and Alexander Prinz
- [TheSamba.com forum](https://www.thesamba.com/vw/forum/viewforum.php?f=5)
- [forum.bulli.org forum](https://forum.bulli.org/)
- [type2.com](http://www.type2.com/m-codes/t2mcodes.html)

## Privacy policy

The data submitted on the form is stored on the site's database. Only those fields submitted are saved,
decoded values are computed on the fly every time an M-plate page is shown.

This is a hobby site without a commercial purpose and without intention to seek financial support. The stored database data
will never be submitted to third parties or used for other purposes than improving the site and providing a better
service to its users.

The code for this site is Open Source. You can explore it and contribute
to the [`vw-type2-id` project on GitLab](https://gitlab.com/dplanella/vw-type2-id).

If you would like to have the data for a particular M-plate removed or amended, feel free to get in touch as per the `Contact`
section.

## Disclaimer

The decoded vehicle data produced on this site comes from multiple sources. Despite best efforts to provide accurate data,
it has to be noted that it comes from volunteer research over 40+ years of history of these vehicles.

As such, data is not guaranteed to be accurate nor to have any legal validity. It should be considered as orientative
only.

## Contact

If you've got feedback or questions about the site, feel free to post them on [the M-Plate decoder thread on TheSamba.com forum](https://www.thesamba.com/vw/forum/viewtopic.php?p=9165728).
You're more than welcome to reach out by private message as well. 

{% endblocktrans %}

{{ about_copy|markdownify }}
  

</div>
</div>

{% endblock %}

mplate_decoder/templates/mplate_decoder/mplate_confirm_delete.html
{% extends "mplate_base_bootstrap.html" %}

{% block content %}

<div class="row mt-4">
<div class="col">
<h1>Delete M-plate</h1>

<p>Are you sure you want to delete M-plate {{ mplate.chassis_number_short }}?</p>

<form action="" method="POST">
  {% csrf_token %}
  <button type="submit" class="btn btn-primary">Yes, delete it</button>
</form>
</div>
</div>

{% endblock %}

mplate_decoder/templates/mplate_decoder/mplate_form.html
{% extends "mplate_base_bootstrap.html" %}

{% load static %}

{% block content %}
{% with mplate_form_7079_id="mplate_form_7079" mplate_form_6869_id="mplate_form_6869" %}

  <div class="row mt-5">
  <div class="col">

  <ul class="nav nav-tabs" id="myTab" role="tablist">
    <li class="nav-item">
      <a class="nav-link active" id="mod6869-tab" data-toggle="tab" href="#mod6869" role="tab" aria-controls="mod6869" aria-selected="true">Model 68-69</a>
    </li>
    <li class="nav-item">
      <a class="nav-link" id="mod7079-tab" data-toggle="tab" href="#mod7079" role="tab" aria-controls="mod7079" aria-selected="false">Model 70-79</a>
    </li>
  </ul>
  <div class="tab-content" id="myTabContent">
    <div class="tab-pane fade show active" id="mod6869" role="tabpanel" aria-labelledby="mod6869-tab">
      {% include "mplate_decoder/mplate_form_6869.html" with form_id=mplate_form_6869_id %}
    </div>
    <div class="tab-pane fade" id="mod7079" role="tabpanel" aria-labelledby="mod7079-tab">
      {% include "mplate_decoder/mplate_form_7079.html" with form_id=mplate_form_7079_id %}
    </div>
  </div>

  </div>
  </div>
{% endwith %}
{% endblock %}

{% block javascript %}

<script type="text/javascript" src="https://cdn.jsdelivr.net/npm/js-cookie@2/src/js.cookie.min.js"></script>
<script type="text/javascript" src="{% static 'js/ajaxformsubmit.js' %}"></script>

{% endblock %}

mplate_decoder/templates/mplate_decoder/mplate_form_6869.html
  {% load crispy_forms_tags %}
  {% load svg %}
  {% load fullurl %}

  <div class="row mt-2">
  <div class="col">
  <form method="post" id="{{ form_id }}" action="">
    {% csrf_token %}

    <h2 class="mt-4">Volkswagen Type 2 M-plate, model year 68-69</h2>

    <p><div class="alert alert-secondary" role="alert">
      Choose your bus' model year tab and fill in the fields to decode your M-plate. Scroll down to the reference info if you need help.
    </div>

    <div class="form-row">
      <div class="form-group col-md-2 mb-0">
        {{ form.production_date|as_crispy_field }}
      </div>
      <div class="form-group col-md-1 mb-0">
        {{ form.emden|as_crispy_field }}
      </div>
    </div>

    {{ form.m_codes_1|as_crispy_field}}

    <div class="form-row">
      <div class="form-group col-md-2 mb-10">
        {{ form.aggregate_code|as_crispy_field }}
      </div>
      <div class="form-group col-md-9 offset-md-1 mb-0">
        {{ form.m_codes_2|as_crispy_field }}
      </div>
    </div>

    <div class="form-row">
      <div class="form-group col-md-2 mb-0">
        {{ form.export_destination|as_crispy_field }}
      </div>
      <div class="form-group col-md-2 mb-0">
        {{ form.model|as_crispy_field }}
      </div>
      <div class="form-group col-md-2 mb-0">
        {{ form.paint_and_interior|as_crispy_field }}
      </div> 
      <div class="form-group col-md-6 mb-0">
        {{ form.chassis_number_short|as_crispy_field }}
      </div>           
    </div>
    <hr class="mb-4">
    <div class="alert alert-info" role="alert">
      Once submitted, the M-plate data will be stored and always available at '{% fullurl 'mplate_decoder:mplate_index' %}CCCCCCC', where 'CCCCCCC' is the shortened chassis number on the plate.
    </div>
    
    {% if object %}
    <button id="btn-update-6869" class="btn btn-primary btn-lg btn-block">Update this M-plate</button>
    {% else %}
    <button id="btn-decode-6869" class="btn btn-primary btn-lg btn-block">Decode this M-plate</button>
    {% endif %}
  </form>
  </div>
  </div>

  <div class="row mt-5">
    <div class="col">
      <h2 id="#reference">Reference</h2>
    </div>
  </div>

  <div class="row mt-4">
    <div class="col-md mt-2">
    {% svg 'mplate-6869-form' %}
    </div>
    <div class="col-md mt-2">
     <ul>
       <li><strong>DDD</strong>: production date. Enter without spaces.</li>
       <li><strong>E</strong>: optional "E", indicates manufacture at the Emden plant.</li>
       <li><strong>M01</strong>: M-codes, first row. Separated by spaces. Might be empty in some plates.</li>
       <li><strong>AA</strong>: aggregate code</li>
       <li><strong>M02</strong>: M-codes, second row. Separated by spaces.</li>
       <li><strong>XXX</strong>: export destination. Two-letter code for worldwide exports. Three-digit or none for German market.</li>
       <li><strong>TTTT</strong>: vehicle model type.</li>
       <li><strong>PPPPII</strong>: paint and interior code.</li>
       <li><strong>CCCCCCC</strong>: shortened chassis number. Enter without spaces.</li>
      </ul>
    </div>
  </div>

<!--
<script type="text/javascript">
  $("#{{ form_id }}").submit(submitForm);
</script>
-->